diff -c dired.el dired-patched-2012-05-26.el
*** dired.el	Sat May 26 09:48:52 2012
--- dired-patched-2012-05-26.el	Sat May 26 10:43:26 2012
***************
*** 2988,3009 ****
  in the case of one marked file, to distinguish that from using
  just the current file."
    (or bufname (setq bufname  " *Marked Files*"))
!   (if (or (eq dired-no-confirm t)
! 	  (memq op-symbol dired-no-confirm)
! 	  ;; If FILES defaulted to the current line's file.
! 	  (= (length files) 1))
!       (apply function args)
!     (with-current-buffer (get-buffer-create bufname)
!       (erase-buffer)
!       ;; Handle (t FILE) just like (FILE), here.
!       ;; That value is used (only in some cases), to mean
!       ;; just one file that was marked, rather than the current line file.
!       (dired-format-columns-of-files (if (eq (car files) t) (cdr files) files))
!       (remove-text-properties (point-min) (point-max)
! 			      '(mouse-face nil help-echo nil)))
!     (save-window-excursion
!       (dired-pop-to-buffer bufname)
!       (apply function args))))
  
  (defun dired-format-columns-of-files (files)
    (let ((beg (point)))
--- 2988,3016 ----
  in the case of one marked file, to distinguish that from using
  just the current file."
    (or bufname (setq bufname  " *Marked Files*"))
!   (let (result)
!     (if (or (eq dired-no-confirm t)
!             (memq op-symbol dired-no-confirm)
!             ;; If FILES defaulted to the current line's file.
!             (= (length files) 1))
!         (setq result  (apply function args))
!       (with-current-buffer (get-buffer-create bufname)
!         (erase-buffer)
!         ;; Handle (t FILE) just like (FILE), here.
!         ;; That value is used (only in some cases), to mean
!         ;; just one file that was marked, rather than the current line file.
!         (dired-format-columns-of-files (if (eq (car files) t) (cdr files) files))
!         (remove-text-properties (point-min) (point-max)
!                                 '(mouse-face nil help-echo nil)))
!       (unwind-protect
!            (save-window-excursion
!              (dired-pop-to-buffer bufname)
!              (setq result  (apply function args)))
!         (ignore-errors
!           (select-window (get-buffer-window bufname 0))
!           (if (one-window-p) (delete-frame) (delete-window)))
!         (bury-buffer bufname)))
!     result))
  
  (defun dired-format-columns-of-files (files)
    (let ((beg (point)))

Diff finished.  Sat May 26 10:48:28 2012
